*  FILE: ADVENT02/ASM

*  <<LOOK>> SPECIAL PROCS

* LOOK BOOKCASE

LOOK01 EQU *
 LDA #120 BOOKCASE
 JSR CKOBJ
 LBEQ NOSEE
 LDA #36+INV PINK CART
 JSR MAKVIS
 BNE A@
 LDA #13+INV RED CART
 JSR MAKVIS
 LBEQ LOOKOB
A@ JSR CKDRAW
 JMP IFOUND

* LOOK DESK

LOOK02 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #124 CLOSED DESK
 BEQ A@
 LDA #16+INV YELLOW CART
 JSR MAKVIS
 BNE B@
 LDA #14+INV KEY
 JSR MAKVIS
 BNE B@
 LDA #20+INV BIRTH CERT
 JSR MAKVIS
 BNE B@
A@ JMP LOOKOB
B@ JSR CKDRAW
 JMP IFOUND

* LOOK TIME MACH SLOT

LOOK03 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA SLOTSW
 LBEQ LOOKOB
 LDX #MSG36
 JSR DISPLY
 JSR OBDESC
 LDA #'.
 JSR CHROUT
 JMP REPLY

* LOOK AT CARTRIDGES

LOOK04 EQU *
 LDA #119 TIME MACH SLOT
 JSR CKOBJ
 BEQ A@
 LDA NOUNNO
 CMPA SLOTSW
 LBEQ DMSG12
A@ JMP LOOKOB

* LOOK SAFE

LOOK05 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #114 LOCKED SAFE
 BEQ A@
 LDA #9+INV BLUE CART
 JSR MAKVIS
 BNE B@
A@ JMP LOOKOB
B@ JMP IFOUND

* LOOK GAUGE

LOOK06 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 TST SLOTSW
 LBEQ DMSG12
 LDA #94 CHARGED BATTERY
 JSR CKOBJ
 BNE C@
 LDA #67
 BRA Z@
C@ LDA ROOM
 CMPA #38
 BNE A@
 LDA #46
 BRA Z@
A@ CMPA #34
 BNE B@
 LDA #45
 BRA Z@
B@ CMPA #16
 BNE D@
 LDA #70
 BRA Z@
D@ CMPA #49
 BNE E@
 LDA #82
 BRA Z@
E@ LDA #44
Z@ JMP DMSGXX

* LOOK DOOR

LOOK07 EQU *
 LDA ROOM
 CMPA #2
 BEQ A@
 CMPA #3
 BEQ A@
 CMPA #24
 LBNE LOOKOB
A@ JMP DMSG12

* LOOK DIAL

LOOK08 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG40

* LOOK COUNTER/WORKBENCH
*      MAE WEST/MUMMY

LOOK09 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 BEQ A@
 LDA #21+INV NOTEBOOK
 JSR MAKVIS
 BNE B@
 LDA #28+INV VIAL
 JSR MAKVIS
 BNE B@
 LDA #23+INV SACK
 JSR MAKVIS
 BNE B@
 LDA #29+INV HACKSAW
 JSR MAKVIS
 BNE B@
 LDA #30+INV HAIR PIN
 JSR MAKVIS
 BNE B@
 LDA #50+INV RUBY NECKLACE
 JSR MAKVIS
 BNE B@
 LDA #51+INV PLATINUM
 JSR MAKVIS
 BNE B@
A@ JMP LOOKOB
B@ JSR CKDRAW
 JMP IFOUND

* LOOK NOTEBOOK

LOOK10 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #22 OPEN NOTEBOOK
 BNE B@
 JSR HAVOBJ
 BEQ B@
 LDA #53
 TST NOTEPG
 BEQ A@
 INCA
A@ JMP DMSGXX
B@ JMP LOOKOB

* LOOK PAGE

LOOK11 EQU *
 LDA #22
 JSR HAVOBJ
 LBEQ NOSEE
 STA NOUNNO
 BRA LOOK10

* LOOK SACK

LOOK12 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 BEQ C@
 TFR A,B
 CMPA #25 EMPTY SACK
 BEQ C@
 INCB
 JSR REPOBJ
 CMPA #23
 BNE A@
 LDA #26 SANDWICH
 BRA B@
A@ LDA #27 LIME
B@ JSR PUTNRM
 JSR CKDRAW
 JMP IFOUND
C@ JMP LOOKOB

* LOOK CHEST

LOOK13 EQU *
 LDA #105 OPEN CHEST
 JSR CKOBJ
 LBEQ LOOKOB
 LDA #31+INV SCEPTER
 JSR MAKVIS
 LBEQ DMSG22
 JSR CKDRAW
 JMP IFOUND

* LOOK TORCH

LOOK14 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #101 TURNED
 BEQ A@
 LDA ROOM
 CMPA #37
 BNE A@
 LDX #MSG58
 BRA B@
A@ LDX #MSG59
B@ JSR DISPLY
 JMP REPLY

* LOOK SKELETON

LOOK15 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA #47+INV SPOON
 JSR MAKVIS
 BNE A@
 LDA #43+INV STRING
 JSR MAKVIS
 BNE A@
 LDA #52+INV BRASS RING
 JSR MAKVIS
 LBEQ LOOKOB
A@ JSR CKDRAW
 JMP IFOUND

*  <<GET>> SPECIAL PROCS

* GET CALENDAR

GET01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 BEQ A@
 CMPA #8
 BNE A@
 LDA OBJCNT
 CMPA #MAXOBJ
 BHS A@
 LDA #8 CAL ON WALL
 LDB #15 CALENDAR
 JSR CHGOBJ
 LDA #114+INV LOCKED SAFE
 JSR MAKVIS
 JSR CKDRAW
 LDX #MSG34
 JSR DISPLY
A@ JMP VGET

* GET CARTRIDGES

GET02 EQU *
 LDA #119 TIME MACH SLOT
 JSR CKOBJ
 BEQ A@
 LDA NOUNNO
 CMPA SLOTSW
 BNE A@
 LDA OBJCNT
 CMPA #MAXOBJ
 LBHS DMSG9
 LDA SLOTSW
 JSR PUTNRM
 CLR SLOTSW
A@ JMP VGET

* GET LEVER

GET03 EQU *
 LDA #89 SARC
 STA NOUNNO
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #83
 BEQ A@
 CMPA #84
 LBNE NOSEE
A@ JMP DMSG21

*  <<PUT>> SPECIAL PROCS

* PUT SUIT

PUT01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 BEQ A@
 CMPA #40 WEARING SUIT
 LBEQ DMSG14
A@ JMP VPUT

*  <<GO>> SPECIAL PROCS

* GO TIME MACH

GO01 EQU *
 LDA #117 TIME MACH GAUGE
 JSR CKOBJ
 LBNE DMSG14
 LDA #121 TIME MACH
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 INCA
 JMP EXITRM

* GO DEVICE

GO02 EQU *
 LDA ROOM
 CMPA #9
 BEQ A@
 CMPA #31
 BEQ A@
 LDA #122 DEVICE
 JSR CKOBJ
 LBEQ NOSEE
 LDA #112 SAFE SIGN
 JSR CKOBJ
 LBEQ DMSG23
 LDA ROOM
 DECA
 JMP EXITRM
A@ JMP DMSG14

* GO OUT

GO03 EQU *
 LDA #117 TIME MACH GAUGE
 JSR CKOBJ
 BEQ C@
 LDA ROOM
 DECA
A@ JMP EXITRM
B@ INCA
 BRA A@
C@ LDA ROOM
 CMPA #9 IN DEVICE
 BEQ B@
 CMPA #31 IN DEVICE
 BEQ B@
 JMP DMSG23

* GO DOOR

GO04 EQU *
 LDA ROOM
 CMPA #2
 BEQ E@
 CMPA #3
 BEQ E@
 CMPA #24
 BEQ E@
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #127 LOCKED DOOR
 LBEQ DMSG17
 CMPA #126 CLOSED DOOR
 LBEQ DMSG16
 LDA ROOM
 CMPA #4
 BNE A@
 LDA #20
 BRA D@
A@ CMPA #20
 BNE B@
 LDA #4
 BRA D@
B@ CMPA #21
 BNE C@
 LDA #22
 BRA D@
C@ LDA #21
D@ JMP EXITRM
E@ JMP DMSG23

* GO HOLE IN WALL

GO05 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 CMPA #51
 BEQ C@
 CMPA #53
 BEQ D@
 CMPA #37
 BEQ A@
 LDA #37
 BRA B@
A@ LDA #46
B@ JMP EXITRM
C@ LDA #53
 BRA B@
D@ LDA #51
 BRA B@

* GO WINDOW

GO06 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #108
 LBEQ DMSG57
 LDA ROOM
 EORA #3
 JMP EXITRM

* GO SECRET PASSAGE

GO07 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDA ROOM
 CMPA #51
 BNE A@
 INCA
 INCA
A@ DECA
 JMP EXITRM

* OPEN DOOR

OPEN01 EQU *
 LDA ROOM
 CMPA #2
 BEQ A@
 CMPA #3
 BEQ A@
 CMPA #24
 BEQ A@
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #127 LOCKED DOOR
 LBEQ DMSG17
 LDB #125 OPEN DOOR
 JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG18
A@ JMP DMSG23

* OPEN DESK

OPEN02 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDB #123 OPEN DESK
 JSR CHGOBJ
 TFR B,A
 JSR CKDRAW
 JMP DMSG18

* OPEN NOTEBOOK

OPEN03 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #22
 JSR REPOBJ
 CLR NOTEPG
 JMP DMSG18

* OPEN SARCOPHAGUS

OPEN04 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #89 CLOSE SARC
 LBNE LOOKOB
 LDB #88 OPEN SARC
 JSR CHGOBJ
 JSR CKDRAW
 LDA #87 MUMMY
 JSR PUTNRM
 JMP IFOUND

* OPEN IRON GATE

OPEN05 EQU *
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 JMP DMSG20

* CLOSE DOOR

CLOS01 EQU *
 LDA ROOM
 CMPA #2
 BEQ B@
 CMPA #3
 BEQ B@
 CMPA #24
 BEQ B@
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #125 OPEN DOOR
 BNE A@
 LDB #126 CLOSED DOOR
 JSR CHGOBJ
 JSR CKDRAW
A@ JMP DMSG16
B@ JMP DMSG23

* CLOSE DESK

CLOS02 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDB #124 CLOSED DESK
 JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG16

* CLOSE NOTEBOOK

CLOS03 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #21
 JSR REPOBJ
 JMP DMSG16

* UNLOCK DOOR

UNLK01 EQU *
 LDA ROOM
 CMPA #2
 BEQ B@
 CMPA #3
 BEQ B@
 CMPA #24
 BEQ B@
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #126 UNLOCKED DOOR
 BEQ A@
 CMPA #127 LOCKED DOOR
 BNE B@
 PSHS D
 LDA #14 KEY
 JSR HAVOBJ
 BEQ B@
 PULS D
 LDB ROOM
 CMPB #4
 LBNE DMSG21
 LDB #126 UNLOCKED DOOR
 JSR CHGOBJ
A@ JMP DMSG19
B@ JMP DMSG23

VINSRT EQU *
 LDA NOUNNO
 CMPA #125 CART
 LBEQ DMSG37
 CMPA #9 BLUE CART
 BEQ A@
 CMPA #13 RED CART
 BEQ A@
 CMPA #16 YELLOW CART
 BEQ A@
 CMPA #36 PINK CART
 BEQ A@
 CMPA #39 WHITE CART
 BEQ A@
 JMP BADINP
A@ JSR HAVOBJ
 LBEQ NOHAVE
 TST SLOTSW
 BNE B@
 LDA #119 TIME MACH SLOT
 JSR CKOBJ
 BNE C@
B@ JMP DMSG23
C@ LDA NOUNNO
 STA SLOTSW
 CLRB
 JSR REPOBJ
 JMP REPLY

VPUSH EQU *
 LDA NOUNNO
 CMPA #118 BUTTON
 LBNE BADINP
 JSR CKOBJ
 LBEQ NOSEE
 LDA #119 TIME MACH SLOT
 JSR CKOBJ
 BNE C@
 LDA ROOM
 CMPA #20
 BEQ G@
 CMPA #21
 BEQ G@
 LDA #112 SAFE SIGN
 JSR CKOBJ
 BNE A@
 LDA #111 UNSAFE SIGN
 LDB #112 SAFE SIGN
 BRA B@
A@ LDB #111 UNSAFE SIGN
B@ JSR CHGOBJ
E@ JMP REPLY
H@ JMP DMSG43
C@ LDA #94 CHARGED BATTERY
 JSR CKOBJ
 BEQ H@
 LDA SLOTSW
 BEQ H@
 LDX #TIMTAB
D@ TST ,X
 BEQ E@
 CMPA ,X++
 BNE D@
 LDB -1,X
 CMPB ROOM
 BEQ E@
 LDA ROOM
 CMPA #34 MUS 1967
 BNE F@
 BSR CHKDEV
F@ JSR XFROBJ
 STB ROOM
 BRA E@
G@ LDA #125 OPEN DOOR
 JSR CKOBJ
 BNE E@
 LDA ROOM
 TFR A,B
 EORB #1
 JSR XFROBJ
 STB ROOM
 BRA E@

* CHECK DEVICE FOR COAL

CHKDEV EQU *
 PSHS D
 DI
 LDA ROOM
 PSHS A
 LDA #31 1967 DEVICE
 STA ROOM
 LDA #11 COAL
 JSR CKOBJ
 BEQ A@
 INC ROOM
 LDA #111 PRESSURE SIGN
 JSR CKOBJ
 BEQ A@
 DEC ROOM
 LDA #11 COAL
 JSR GETOBJ
 LDA #9 DEVICE 2063
 STA ROOM
 LDA #32 DIAMOND
 JSR PUTNRM
 INC ROOM
 LDA #112 ALL CLEAR SIGN
 LDB #111 PRESSURE SIGN
 JSR CHGOBJ
A@ PULS A
 STA ROOM
 EI
 PULS D,PC

* EAT VERB PROC

VEAT EQU *
 LDB NOUNNO
 JSR EQUOBJ
 LDA NOUNNO
 LBEQ BADINP
 JSR HAVOBJ
 LBEQ NOHAVE
 CMPA #40 WEARING SUIT
 LBEQ DMSG14
 CMPB #27 LIME
 BEQ A@
 CMPB #26 SANDWICH
 LBNE DMSG26
A@ CLRB
 JSR REPOBJ
 JMP REPLY

* DIG

VDIG EQU *
 LDA #12 SHOVEL
 JSR HAVOBJ
 LBEQ DMSG23
 LDA #91 OCEAN WATER
 JSR CKOBJ
 LBEQ DMSG26
 JMP REPLY

* GIVE VERB PROC

VGIVE EQU *
 LDA #92 MUTANT
 JSR CKOBJ
 LBEQ DMSG23
 JSR EQUOBJ
 LDA NOUNNO
 LBEQ BADINP
 JSR HAVOBJ
 LBEQ NOHAVE
 CLRB
 CMPA #26 SANDWICH
 BNE A@
 LDB #39 WHITE CART
 PSHS D
 LDX #MSG73
 JSR DISPLY
 LDA #92 MUTANT
 CLRB
 JSR CHGOBJ
 JSR CKDRAW
 PULS D
A@ JSR REPOBJ
 JMP REPLY

* GIVE RING

GIVE01 EQU *
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #87   MUMMY
 JSR CKOBJ
 LBEQ DMSG23
 LDX #MSG90
 JSR DISPLY
 LDB #82  PASSAGE
 JSR CHGOBJ
 LDA #88 OPEN SARC
 LDB #84 EMPTY SARC
 JSR CHGOBJ
 JSR CKDRAW
 LDA NOUNNO
 CLRB
 JSR REPOBJ
 LDA #89
 JMP DMSGXX

* WEAR SUIT

WEAR01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #40
 JSR REPOBJ
 JMP DMSG14

* REMOVE SUIT

REMO01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDB #37
 JSR REPOBJ
 JMP REPLY

* POUR VIAL/ACID

POUR01 EQU *
 LDA #33 FULL VIAL
 JSR HAVOBJ
 LBEQ DMSG23
 LDA #96 DRY BATTERY
 JSR CKOBJ
 BEQ B@
 LDB #95 FULL BATTERY
 JSR CHGOBJ
 LDA #8 CHARGE COUNT
 STA BATTSW
 LDX #MSG65
A@ JSR DISPLY
 LDA #33 FULL VIAL
 LDB #28 EMPTY VIAL
 JSR REPOBJ
 JMP REPLY
B@ LDA #93 PUDDLE
 JSR PUTNRM
 LDX #MSG64
 BRA A@

* MELT/HEAT WAX/BIRD

MELT01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #101 TURNED TORCH
 JSR CKOBJ
 BNE A@
 LDA #102 TORCHES
 JSR CKOBJ
 LBEQ DMSG23
A@ LDA #46 BIRD
 LDB #42 SOFT WAX
 JSR REPOBJ
 LDA #41 HARD WAX
 JSR REPOBJ
 LDA #6
 STA WAXSW
 JMP REPLY

* LIGHT CANDLE

LITE01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 CMPA #45 LIT CANDLE
 BEQ B@
 LDA #101
 JSR CKOBJ
 BNE A@
 LDA #102 TORCH
 JSR CKOBJ
 LBEQ DMSG26
A@ LDA #44 UNLIT CANDLE
 LDB #45 LIT CANDLE
 JSR REPOBJ
 INC LITESW
B@ JMP DMSG28

* UNLIGHT CANDLE

UNLI01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 LDA #45 LIT CANDLE
 LDB #44 UNLIT CANDLE
 JSR REPOBJ
 CLR LITESW
 JMP DMSG29

* MAKE CANDLE

MAKE01 EQU *
 LDA #42 SOFT WAX
 JSR HAVOBJ
 BEQ A@
 INCA
 JSR HAVOBJ
A@ LBEQ DMSG23
 LDB #44 UNLIT CANDLE
 JSR REPOBJ
 LDA #42 SOFT WAX
 CLRB
 JSR REPOBJ
 JMP REPLY

* SQUEEZE LIME

SQU01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR HAVOBJ
 LBEQ NOHAVE
 CMPA #34 LIME HALVES
 LBNE DMSG43
 LDB #35 PEELS
 JSR REPOBJ
 LDA #28 VIAL
 JSR HAVOBJ
 BEQ A@
 LDB #33 FULL VIAL
 JSR REPOBJ
 LDX #MSG63
 BRA B@
A@ LDA #93 PUDDLE
 JSR PUTNRM
 LDX #MSG64
B@ JSR DISPLY
 JMP REPLY

* TURN 99

VTURN EQU *
 LDX #NOUN
VTURN1 EQU *
 LDA 3,X
 CMPA #' '
 BNE C@
 LDA 2,X
 CMPA #' '
 BNE C@
 LDA 1,X
 CMPA #' '
 BNE A@
 LDA ,X
 STA 1,X
 LDA #'0'
 STA ,X
A@ LDA 1,X
 TFR A,B
 CMPA #'0'
 BLO C@
 CMPA #'9'
 BHI C@
 LDA ,X
 CMPA #'0'
 BLO C@
 CMPA #'9'
 BHI C@
 TFR D,Y
 LDA #114 LOCKED SAFE
 STA NOUNNO
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 TFR Y,D
 CMPA #'1'
 BEQ D@
 CMPA #'2'
 BEQ E@
 CMPA #'4'
 BEQ F@
B@ CLR DIALSW
G@ JMP REPLY
C@ JMP BADINP
D@ CMPB #'1'
 BNE B@
 LDA DIALSW
 BNE B@
 INC DIALSW
 BRA G@
E@ CMPB #'9'
 BNE B@
 LDA DIALSW
 CMPA #1
 BNE B@
 INC DIALSW
 BRA G@
F@ CMPB #'2'
 BNE B@
 LDA DIALSW
 CMPA #2
 BNE B@
 LDA #114 LOCKED SAFE
 JSR CKOBJ
 BEQ B@
 LDB #113 OPEN SAFE
 JSR CHGOBJ
 JSR CKDRAW
 JMP DMSG18

* TURN DIAL

TURN01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 LDX #MSG50
 JSR DISPLY
 JSR GETLIN
 JSR SCNKEY
 LDX #VERB
 JMP VTURN1

* TURN/PULL/MOVE TORCH

TURN02 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #101 TURNED TORCH
 BEQ C@
 LDB ROOM
 CMPB #37
 BNE C@
 LDB #101 TURNED TORCH
 JSR CHGOBJ
 JSR CKDRAW
 LDB #26
 CALCX 20,55
A@ PSHS B
 CALCD 20,55,66,80
 JSR SCRRIT
 LDA #45
 JSR SHOOVL
 LDY #1000
B@ LEAY -1,Y
 BNE B@
 PULS B
 DECB
 BNE A@
 LDA #100 HOLE IN WALL
 JSR PUTNRM
 JMP IFOUND
C@ JMP DMSG20

* TURN PAGE

TURN03 EQU *
 LDA #22 OPEN NOTEBOOK
 JSR HAVOBJ
 LBEQ DMSG23
 LDA NOTEPG
 INCA
 CMPA #1
 BEQ A@
 CLRA
A@ STA NOTEPG
 JMP REPLY

* TURN/PULL/MOVE LEVER

TURN04 EQU *
 LDA #89 SARC
 STA NOUNNO
 JSR EQUOBJ
 LDA NOUNNO
 CMPA #83
 BEQ A@
 CMPA #84
 BEQ B@
 JMP NOSEE
A@ LDB #84 SARC
 JSR CHGOBJ
 LDA #81 HOLE IN FLOOR
 CLRB
 JSR CHGOBJ
 LDA #238 REMOVE HOLE
 JSR SHOOVL
 CALCX 49,17
 CALCD 49,17,78,76
 LDY #12
D@ JSR SCRRIT
 LEAY -1,Y
 BNE D@
 BRA C@
B@ LDB #83 SARC
 JSR CHGOBJ
 LDA #81 HOLE IN FLOOR
 JSR PUTNRM
 CALCX 49,17
 CALCD 49,17,78,76
 LDY #12
E@ JSR SCRLFT
 LEAY -1,Y
 BNE E@
 LDA #223 HOLE IN FLOOR
 JSR SHOOVL
C@ JMP REPLY

* SAW WINDOW

SAW01 EQU *
 JSR EQUOBJ
 LDA NOUNNO
 JSR CKOBJ
 LBEQ NOSEE
 CMPA #108 BARRED WINDOW
 LBNE DMSG26
 LDA #29 SAW
 JSR HAVOBJ
 LBEQ DMSG23
 LDA #108 BARRED WINDOW
 LDB #107 OPEN WINDOW
 JSR CHGOBJ
 TFR B,A
 JSR CKDRAW
 JMP REPLY

* SAW/CUT LIME

SAW02 EQU *
 JSR EQUOBJ
 LDA #29 HACKSAW
 JSR HAVOBJ
 BEQ A@
 LDA NOUNNO
 CMPA #27 LIME
 BNE A@
 JSR HAVOBJ
 BEQ A@
 LDB #34 LIME HALVES
 JSR REPOBJ
 JMP REPLY
A@ JMP DMSG23

* PICK LOCK

PICK01 EQU *
 LDA #30 HAIR PIN
 JSR HAVOBJ
 BEQ A@
 LDA #127 LOCKED DOOR
 JSR CKOBJ
 LBNE DMSG21
 LDA #106 LOCKED CHEST
 JSR CKOBJ
 BEQ A@
 LDB #105 OPEN CHEST
 JSR CHGOBJ
 TFR B,A
 JSR CKDRAW
 LDA #92
 JMP DMSGXX
A@ JMP DMSG26

*******************************
* CHECK FOR DARK AREA RTN
* CALLED FROM VLOOK
*
* RETURN WITH ZERO IF DARK
*******************************

INDARK EQU *
 PSHS B,X,Y,U
 LDA ROOM
 CMPA #48
 BLO A@
 CMPA #49
 BEQ A@
 LDA #45 LIT CANDLE
 JSR LOCOBJ
 BNE A@
 LDU #SCRBLK
 JSR SHOSCR
 JSR CLSTXT
 LDD #$0B00
 STD ROWCOL
 LDX #MSG84
 JSR DISPLY
 CLRA
A@ TSTA
 PULS B,X,Y,U,PC

*******************************
* ROUTINE PERFORMED FOR EACH
* ITEM OF A PUT ALL.  ROUTINE
* SHOULD SET "A" REG TO ZERO
* IF NOT ALLOWED TO PUT DOWN.
*
* INPUT: A=OBJECT PUTTING DOWN
*******************************

CHKPA EQU *
 CMPA #40 WEARING SUIT
 BNE A@
 CLRA
A@ TSTA
 RTS

*******************************
* ROUTINE PERFORMED FOR EACH
* ITEM OF A GET ALL.  ROUTINE
* SHOULD SET "A" REG TO ZERO
* IF NOT ALLOWED TO PICK UP.
*
* INPUT: A=OBJECT PICKING UP
*******************************

CHKGA EQU *
 CMPA #8 CALENDAR ON WALL
 BNE A@
 CLRA
A@ TSTA
 RTS

*******************************
* ROUTINE PERFORMED AFTER EACH
* VALID MOVE
*******************************

ECHMOV EQU *
 PSHS D,X,Y,U
 BSR CKBATT CHK BATTERY
 BSR CKHIDE HIDE OBJ IN CASTLE
 JSR CKRADI CHK RADIATION
 BSR CKWAX  CHK SOFT WAX
 JSR CKLITE CHK CANDLE
 PULS D,X,Y,U,PC

CKWAX EQU *
 TST WAXSW
 BEQ A@
 DEC WAXSW
 BNE A@
 LDA #42 SOFT WAX
 LDB #41 HARD WAX
 JSR XCHGOB
A@ RTS

CKBATT EQU *
 TST BATTSW
 BEQ A@
 DEC BATTSW
 BNE A@
 LDA #95 BATTERY
 LDB #94 CHARGED BATTERY
 JSR XCHGOB
A@ RTS

CKHIDE EQU *
 LDA ROOM
 CMPA #36
 BLO A@
 CMPA #46
 BHI A@
 LDA RANDOM
 ANDA #$7F
 CMPA #30
 BHI A@
 BSR HIDOBJ
A@ RTS

HIDOBJ EQU *
 LDA ROOM
 STA E@
 DI
 LDA #40
A@ STA ROOM
 CMPA E@
 BEQ D@
 JSR PNTRM1
B@ LDA ,X+
 BEQ D@
 CMPA #MXMVOB
 BHI B@
 CMPA #17 SAPPHIRE
 BEQ B@
 CMPA #18 NUGGET
 BEQ B@
 JSR GETOBJ
 LDB #46
 STB ROOM
 JSR PUTNRM
 LDX #MSG68
 JSR DISPLY
 JSR OBDESC
 LDX #MSG69
 JSR DISPLY
C@ LDA E@
 STA ROOM
 EI
 RTS
D@ LDA ROOM
 INCA
 CMPA #46
 BLO A@
 BRA C@
E@ FCB 0

CKRADI EQU *
 LDA RADISW
 BEQ E@
 DECA
 BNE A@
 LDX #MSG77
 PSHS X
 JMP DEAD2
A@ STA RADISW
 CMPA #20
 BNE B@
 LDX #MSG74
 BRA D@
B@ CMPA #12
 BNE C@
 LDX #MSG75
 BRA D@
C@ CMPA #5
 BNE E@
 LDX #MSG76
D@ JSR DISPLY
E@ RTS

CKLITE EQU *
 TST LITESW
 BEQ B@
 DEC LITECT
 BNE A@
 CLR LITESW
 LDA #45 LIT CANDLE
 CLRB
 JSR XCHGOB
 JSR INDARK
 BRA B@
A@ LDB LITECT
 CMPB #9
 BHI B@
 CLRA
 TFR D,X
 LDY #MSG25A
 JSR ASCLNO
 JSR SUPRES
 LDA MSG25A+4
 STA MSG83A
 LDX #MSG83
 JSR DISPLY
B@ RTS

*******************************
*   IN ROOM ROUTINES
*******************************

INRM15 EQU *
 PSHS D
 TST RADISW
 BNE A@
 LDA #40 WEARING SUIT
 JSR HAVOBJ
 BNE A@
 LDA #25
 STA RADISW
A@ LDA #92 MUTANT
 JSR CKOBJ
 BEQ B@
 LDA RANDOM
 ANDA #$7F
 CMPA #8
 BHI B@
 LDX #MSG78
 PSHS X
 JMP DEAD2
B@ PULS D,PC

INRM48 EQU *
 PSHS D
 LDA #45 LIT CANDLE
 JSR LOCOBJ
 BNE A@
 LDA RANDOM
 ANDA #$7F
 CMPA #50
 BHI A@
 LDX #MSG30
 PSHS X
 JMP DEAD2
A@ PULS D,PC

*******************************
*   ENTER ROOM ROUTINES
*******************************

ENTR41 EQU *
 PSHS D,X
 LDX #MSG56
 JSR DISPLY
 PULS D,X,PC

*******************************
*   EXIT ROOM ROUTINES
*******************************

*******************************
*  ANTIMATION ROUTINES
*******************************

* FLIP TORCHES IN CASTLE

MOVTOR EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #12
 BLO D@
 CLRD
 STD FLIPCT
 LDA FLIPSW
 BEQ B@
 DECA
 BEQ A@
 CLR FLIPSW
 DEC FLIPSW
 LDA #54
 BRA C@
A@ LDA #52
 BRA C@
B@ LDA #50
C@ JSR SHOOVL
 INCA
 JSR SHOOVL
 INC FLIPSW
D@ RTS

* MOVE FISH IN AQUATIC EXHIBIT

MOVFSH EQU *
 LDX FLIPCT
 LEAX 1,X
 STX FLIPCT
 CMPX #5
 BEQ A@
 CMPX #10
 BLO B@
 CLR FLIPCT
 CLR FLIPCT+1
 CALCX 20,17
 CALCD 20,17,33,56
 JSR SCRLFT
A@ CALCX 36,69
 CALCD 36,69,41,108
 JSR SCRRIT
B@ RTS

* MOVE TUBES IN SCIENCE LAB

MOVLAB EQU *
 INC FLP2CT+1
 LDA FLP2CT+1
 CMPA #2
 BLO A@
 CLR FLP2CT+1
 LDB FLIPSW
 INCB
 ANDB #3
 STB FLIPSW
 CMPB #3
 BEQ A@
 ADDB #16 TUBES OVERLAYS
 LDA #OV2
 JSR SHOOVL
 CALCX 42,109
 CALCD 42,109,47,112
 JSR SCRDN
* CHK FOR ELECTRICITY FLASH
A@ INC FLIPCT+1
 LDA FLIPCT+1
 CMPA #4
 BEQ B@
 CMPA #90
 BEQ B@
 CMPA #92
 BEQ B@
 CMPA #94
 BLO C@
 CLR FLIPCT+1
B@ LDB FLIPCT
 INC FLIPCT
 ANDB #3
 BEQ X@
 LDA RANDOM
 ANDA #$7F
 CMPA #50
 BLO C@
X@ ADDB #19
 LDA #OV2
 JSR SHOOVL
* FLIP METER INDICATOR
C@ INC FLP2CT
 LDA FLP2CT
 CMPA #50
 BLO E@
 CLR FLP2CT
 LDB FLP2SW
 INCB
 CMPB #3
 BLO D@
 CLRB
D@ STB FLP2SW
 ADDB #23
 LDA #OV2
 JSR SHOOVL
E@ RTS

* MOVE MUTANT ON BEACH

MOVMUT EQU *
 LDA #92 MUTANT
 JSR CKOBJ
 BEQ B@
 INC FLIPCT
 LDA FLIPCT
 CMPA #15
 BLO A@
 CLR FLIPCT
 LDB FLIPSW
 EORB #1
 STB FLIPSW
 ADDB #51
 LDA #OV2
 JSR SHOOVL
A@ INC FLP2CT
 LDA FLP2CT
 CMPA #25
 BLO B@
 CLR FLP2CT
 LDB FLP2SW
 EORB #1
 STB FLP2SW
 ADDB #53
 LDA #OV2
 JSR SHOOVL
B@ RTS


*
* END OF FILE: ADVENT02/ASM
*
